// GameWindow.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "resource.h"
#include "Watson.h"
#include "GameWindow.h"
#include "GameApp.h"
#include "Tutorial.h"
#include "Options.h"
#include "Score.h"
#include "Bid.h"
#include "Announce.h"
#include "About.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CEvaluation eval;

COLORREF white=RGB(255,255,255);	
COLORREF black=RGB(0,0,0);	
COLORREF red=RGB(255,0,0);	

const int key_w=48;			//Breite der Tasten
const int key_h=71;			//He der Tasten
const int key_y=177;		//"Ndliches Ende der Tasten  Auswertung
const int key_s=key_y+key_h;//"SEliches" Ende der Tasten
const int l=3;				//Linker Rand Tastenfeld
const int L=14;	//linker Rand
const int U=20;	//oberer Rand des Spielfeldes

//color:
const int KARO=1;
const int HERZ=2;
const int PIK=3;
const int KREUZ=4;
//value:
const int BUBE=2;
const int DAME=3;
const int KOENIG=4;
const int ZEHN=10;
const int AS=11;

//index
//			KARO	HERZ	PIK		KREUZ
//BUBE		1		2		3		4
//DAME		5		6		7		8
//KOENIG	9		10		11		12
//ZEHN		13		14		15		16
//AS		17		18		19		20


/////Redeklaration Globale Variablen/////////////
extern bool playsound;
extern bool increase;
extern int level;
extern int pk;	//PillKind	
extern int score;
extern int highscore;
/////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// GameWindow

GameWindow::GameWindow(LPCSTR ClassName)
{	
	width=800;	//Die Fenstergre 
	height=600;	
		
    int xoffset=(::GetSystemMetrics(SM_CXSCREEN) - width) / 2; //zentrieren
	int yoffset=(::GetSystemMetrics(SM_CYSCREEN) - height) / 2;

	Create(ClassName,"Watson's Card Game: 1001",
		WS_OVERLAPPED|WS_SYSMENU|WS_MINIMIZEBOX,
		CRect(xoffset,yoffset,xoffset+width,yoffset+height)
		,NULL,"MAINMENU");			
	
	redPen.CreatePen(PS_SOLID,2,RGB(255,0,0));
	blackPen.CreatePen(PS_SOLID,2,RGB(0,0,0));
	redBrush.CreateSolidBrush(RGB(255,0,0));		
	
	bg.LoadBitmap(IDB_BG1);

	bg1.LoadBitmap(IDB_BG3);
	pbg1=&bg1;

	bg2.LoadBitmap(IDB_BG4);
	pbg2=&bg2;	

	medail[0].LoadBitmap(IDB_BOY);		pmedail[0]=&medail[0];	
	medail[1].LoadBitmap(IDB_QUEEN);	pmedail[1]=&medail[1];
	medail[2].LoadBitmap(IDB_KING);		pmedail[2]=&medail[2];	
	
	bigsymbol[0].LoadBitmap(IDB_KARO);	pbigsymbol[0]=&bigsymbol[0];
	bigsymbol[1].LoadBitmap(IDB_HERZ);	pbigsymbol[1]=&bigsymbol[1];
	bigsymbol[2].LoadBitmap(IDB_PIK);	pbigsymbol[2]=&bigsymbol[2];
	bigsymbol[3].LoadBitmap(IDB_KREUZ);	pbigsymbol[3]=&bigsymbol[3];

	smallsymbol[0].LoadBitmap(IDB_KARO1);	psmallsymbol[0]=&smallsymbol[0];
	smallsymbol[1].LoadBitmap(IDB_HERZ1);	psmallsymbol[1]=&smallsymbol[1];
	smallsymbol[2].LoadBitmap(IDB_PIK1);	psmallsymbol[2]=&smallsymbol[2];
	smallsymbol[3].LoadBitmap(IDB_KREUZ1);	psmallsymbol[3]=&smallsymbol[3];
			
	smallsymbol[4].LoadBitmap(IDB_HERZ2);	psmallsymbol[4]=&smallsymbol[4];
	smallsymbol[5].LoadBitmap(IDB_PIK2);	psmallsymbol[5]=&smallsymbol[5];
	smallsymbol[6].LoadBitmap(IDB_KREUZ2);	psmallsymbol[6]=&smallsymbol[6];

	letter[0].LoadBitmap(IDB_BR1);		pletter[0]=&letter[0];
	letter[1].LoadBitmap(IDB_BR2);		pletter[1]=&letter[1];
	letter[2].LoadBitmap(IDB_BS1);		pletter[2]=&letter[2];
	letter[3].LoadBitmap(IDB_BS2);		pletter[3]=&letter[3];

	letter[4].LoadBitmap(IDB_QR1);		pletter[4]=&letter[4];
	letter[5].LoadBitmap(IDB_QR2);		pletter[5]=&letter[5];
	letter[6].LoadBitmap(IDB_QS1);		pletter[6]=&letter[6];
	letter[7].LoadBitmap(IDB_QS2);		pletter[7]=&letter[7];

	letter[8].LoadBitmap(IDB_KR1);		pletter[8]=&letter[8];
	letter[9].LoadBitmap(IDB_KR2);		pletter[9]=&letter[9];
	letter[10].LoadBitmap(IDB_KS1);		pletter[10]=&letter[10];
	letter[11].LoadBitmap(IDB_KS2);		pletter[11]=&letter[11];

	letter[12].LoadBitmap(IDB_10R1);	pletter[12]=&letter[12];
	letter[13].LoadBitmap(IDB_10R2);	pletter[13]=&letter[13];
	letter[14].LoadBitmap(IDB_10S1);	pletter[14]=&letter[14];
	letter[15].LoadBitmap(IDB_10S2);	pletter[15]=&letter[15];

	letter[16].LoadBitmap(IDB_AR1);		pletter[16]=&letter[16];
	letter[17].LoadBitmap(IDB_AR2);		pletter[17]=&letter[17];
	letter[18].LoadBitmap(IDB_AS1);		pletter[18]=&letter[18];
	letter[19].LoadBitmap(IDB_AS2);		pletter[19]=&letter[19];

	no_symbol[0].LoadBitmap(IDB_NO_KARO);	pno_symbol[0]=&no_symbol[0];
	no_symbol[1].LoadBitmap(IDB_NO_HERZ);	pno_symbol[1]=&no_symbol[1];
	no_symbol[2].LoadBitmap(IDB_NO_PIK);	pno_symbol[2]=&no_symbol[2];
	no_symbol[3].LoadBitmap(IDB_NO_KREUZ);	pno_symbol[3]=&no_symbol[3];

	lcard.LoadBitmap(IDB_CARD);	plcard=&lcard;

	//Die KartenrEkseiten-Muster

	pattern.LoadBitmap(IDB_BG2);
	ppattern=&pattern;

	pattern1.LoadBitmap(IDB_BG5);
	ppattern1=&pattern1;

	pattern2.LoadBitmap(IDB_BG6);
	ppattern2=&pattern2;

	cardback1.LoadBitmap(IDB_CARDBACK1);	pcardback1=&cardback1;
	cardback2.LoadBitmap(IDB_CARDBACK2);	pcardback2=&cardback2;
	cardback3.LoadBitmap(IDB_CARDBACK3);	pcardback3=&cardback3;

	CClientDC dc(this);
	memDC.CreateCompatibleDC(&dc);
	membmp.CreateCompatibleBitmap(&dc, width, height);
	memDC.SelectObject(&membmp);

	bgDC.CreateCompatibleDC(&dc);
	bgDC.SelectObject(&bg);	//Hintergrundkachel wlen
	
	font1.CreatePointFont(120,"Arial",&dc);
	font2.CreateFont(300,0,0,0,FW_BOLD,
		0,0,0,ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
		DEFAULT_QUALITY, DEFAULT_PITCH || FF_DONTCARE,
		"Times New Roman");

	GameApp* gApp = (GameApp*)AfxGetApp();
    gApp->gw = this;

	LoadAccelTable("IDR_ACCELERATOR");

	loadSettings();

	sound1.LoadFromRes("SOUND1", NULL); //Sounds aus Ressource
	sound2.LoadFromRes("SOUND2", NULL); 
	sound3.LoadFromRes("SOUND3", NULL);
	sound4.LoadFromRes("SOUND4", NULL);
	
	//SetTimer(IDT_TIMER2,50,NULL);	

	SetTimer(IDT_TIMER4,300,NULL);	

	speed=350;

	beginningPlayer=0;

	playedGames=0;

	m_cheat=false;

	fig=0;

	mayClick=false;		
}

GameWindow::~GameWindow()
{
	saveSettings();

	memDC.DeleteDC();	
	membmp.DeleteObject();	
	
	redPen.DeleteObject();
	blackPen.DeleteObject();
	redBrush.DeleteObject();
	font1.DeleteObject();
	font2.DeleteObject();

	int i;

	for(i=0;i<3;i++)
		medail[i].DeleteObject();

	for(i=0;i<4;i++)
		bigsymbol[i].DeleteObject();

	for(i=0;i<7;i++)
		smallsymbol[i].DeleteObject();	

	pattern.DeleteObject();
	
}


BEGIN_MESSAGE_MAP(GameWindow, CFrameWnd)
	//{{AFX_MSG_MAP(GameWindow)
	ON_WM_KEYDOWN()	
	ON_WM_KEYUP()
	ON_WM_LBUTTONDOWN()	
	ON_WM_LBUTTONUP()
	ON_WM_TIMER()
	ON_COMMAND(ID_GAME_EXIT, OnGameExit)
	ON_WM_CLOSE()
	ON_COMMAND(ID_HELP_TUTORIAL, OnHelpTutorial)
	ON_COMMAND(ID_HELP_ABOUT, OnHelpAbout)
	ON_COMMAND(ID_GAME_NEW, OnGameNew)	
	ON_COMMAND(ID_GAME_EVALUATION, OnGameEvaluation)	
	ON_COMMAND(ID_OPTIONS_SETTINGS, OnOptionsSettings)
	ON_WM_PAINT()	
	ON_WM_MOUSEMOVE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen  Nachrichten GameWindow 

void GameWindow::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{	
	if(nChar==VK_SPACE)
	{
	
	}
}

void GameWindow::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags) 
{		
}

void GameWindow::OnLButtonUp(UINT nFlags, CPoint point) 
{		
	dragMode=false;
}

void GameWindow::OnTimer(UINT nIDEvent) 
{	
	CFrameWnd::OnTimer(nIDEvent);	

	if(::GetSystemMetrics(SM_CXSCREEN)<800||::GetSystemMetrics(SM_CYSCREEN)<600)
	{
		KillTimer(IDT_TIMER1);
		KillTimer(IDT_TIMER2);
		KillTimer(IDT_TIMER3);
		KillTimer(IDT_TIMER4);

		MessageBox("Please use a screen resolution of 800 x 600 or greater", "ERROR, terminating program");
		
		DestroyWindow();
	}	

	if(nIDEvent==IDT_TIMER1)
	{
		if(gameTick<6)gameTick++;
		   else gameTick=3;	

		driveGame();	

		drawStuff();
	}

	else if(nIDEvent==IDT_TIMER2)
	{
			
	}

	else if(nIDEvent==IDT_TIMER3)
	{
		clickTimeSpan=true;
	}

	else if(nIDEvent==IDT_TIMER4)
	{
		ShowSplashScreen(fig);

		fig++;

		if(fig<5&&sound)sound3.Play();
		
		if(fig>6)
		{
			OnGameNew();
			KillTimer(IDT_TIMER4);
		}

		drawStuff();
	}	
}

void GameWindow::drawStuff()
{
	CBrush br;
	
	br.CreatePatternBrush(pbg2);

	memDC.SelectObject(&br);

	memDC.Rectangle(-5, -5, width+5, height+5);

	memDC.SelectStockObject(WHITE_BRUSH);

	br.DeleteObject();

	drawFans();

	drawPiles();

	//drawDebug();

	drawMessages();

	ShowSplashScreen(fig);
	
	CClientDC dc(this);	
	
	dc.BitBlt(0,0,width,height,&memDC,0,0,SRCCOPY);	
}

void GameWindow::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	drawStuff();	
}

void GameWindow::OnHelpTutorial() 
{
	Tutorial dlgTut;
		dlgTut.DoModal();		
}

void GameWindow::OnHelpAbout() 
{
	CAbout dlgAbout;
	dlgAbout.DoModal();
}

void GameWindow::OnClose() 
{
DestroyWindow();	
}

void GameWindow::OnGameExit() 
{
DestroyWindow();	
}

void GameWindow::OnGameEvaluation() 
{	
	if(eval.DoModal()==IDCANCEL)
		DestroyWindow();
}

void GameWindow::OnOptionsSettings() 
{
	Options dlgOpt;

	dlgOpt.m_cheat=m_cheat;
	dlgOpt.sound=sound;
	dlgOpt.cardcolor=cardcolor;
	dlgOpt.m_name1=name1;
	dlgOpt.m_name2=name2;
	dlgOpt.m_name3=name3;

	if(dlgOpt.DoModal()==IDOK)
	{
		m_cheat=dlgOpt.m_cheat;
		sound=dlgOpt.sound;
		cardcolor=dlgOpt.cardcolor;
		name1=dlgOpt.m_name1;
		name2=dlgOpt.m_name2;
		name3=dlgOpt.m_name3;
	}
}

void GameWindow::drawCard(int x, int y, int col, int val)
{	
	if(val==0)
	{
		CBrush br;

		br.CreateSolidBrush(RGB(230,230,200));

		memDC.SelectObject(&br);

		memDC.RoundRect(x,y,x+120,y+170,20,20);

		memDC.SelectStockObject(WHITE_BRUSH);

		br.DeleteObject();

		if(cardcolor==1)
		br.CreatePatternBrush(ppattern);
		else if(cardcolor==2)
		br.CreatePatternBrush(ppattern1);
		else if(cardcolor==3)
		br.CreatePatternBrush(ppattern2);

		memDC.SelectObject(&br);

		memDC.RoundRect(x+6,y+6,x+114,y+164,12,12);

		memDC.SelectStockObject(WHITE_BRUSH);

		br.DeleteObject();

		if(cardcolor==1)
		pcardback1->DrawTransparent(&memDC,x+25,y+50,RGB(255,255,255));
		if(cardcolor==2)
		pcardback2->DrawTransparent(&memDC,x+25,y+50,RGB(255,255,255));
		if(cardcolor==3)
		pcardback3->DrawTransparent(&memDC,x+25,y+50,RGB(255,255,255));
	}

	else
		memDC.RoundRect(x,y,x+120,y+170,20,20);


//////////Medaillons in der Mitte////////////////////

	if(val>0&&val<5)	//Bube, Dame, Knig
		pmedail[val-2]->Draw(&memDC,x+13,y+28);

/////////////////////////////////////////////////////

/////////Kleine Symbole in den Ecken/////////////////

	if(val>0)
	{
	psmallsymbol[col-1]->Draw(&memDC,x+90,y+8);

	psmallsymbol[col==1?0:col+2]->Draw(&memDC,x+10,y+142);
	}

/////////////////////////////////////////////////////

////////////Grosses Symbol in der Mitte//////////////

	if(val>9)	//Zehn oder As
		pbigsymbol[col-1]->Draw(&memDC,x+((col==2)?42:45),y+67);

/////////////////////////////////////////////////////

/////////Schrift in Ecken////////////////////////////
if((col==1&&val==2)||(col==2&&val==2))	//roter Bube
{
	pletter[0]->Draw(&memDC,x+10,y+10);
	pletter[1]->Draw(&memDC,x+95,y+145);
}

else if((col==3&&val==2)||(col==4&&val==2)) //schwarzer Bube
{
	pletter[2]->Draw(&memDC,x+10,y+10);
	pletter[3]->Draw(&memDC,x+95,y+145);
}

else if((col==1&&val==3)||(col==2&&val==3)) //rote Dame
{
	pletter[4]->Draw(&memDC,x+10,y+10);
	pletter[5]->Draw(&memDC,x+95,y+145);
}

else if((col==3&&val==3)||(col==4&&val==3)) //schwarze Dame
{
	pletter[6]->Draw(&memDC,x+10,y+10);
	pletter[7]->Draw(&memDC,x+95,y+145);
}

else if((col==1&&val==4)||(col==2&&val==4)) //roter Knig
{
	pletter[8]->Draw(&memDC,x+10,y+10);
	pletter[9]->Draw(&memDC,x+95,y+145);
}

else if((col==3&&val==4)||(col==4&&val==4)) //schwarzer Knig
{
	pletter[10]->Draw(&memDC,x+10,y+10);
	pletter[11]->Draw(&memDC,x+95,y+145);
}

else if((col==1&&val==10)||(col==2&&val==10)) //rote Zehn
{
	pletter[12]->Draw(&memDC,x+10,y+10);
	pletter[13]->Draw(&memDC,x+95,y+145);
}

else if((col==3&&val==10)||(col==4&&val==10)) //schwarze Zehn
{
	pletter[14]->Draw(&memDC,x+10,y+10);
	pletter[15]->Draw(&memDC,x+95,y+145);
}

else if((col==1&&val==11)||(col==2&&val==11)) //rotes As
{
	pletter[16]->Draw(&memDC,x+10,y+10);
	pletter[17]->Draw(&memDC,x+95,y+145);
}

else if((col==3&&val==11)||(col==4&&val==11)) //schwarzes As
{
	pletter[18]->Draw(&memDC,x+10,y+10);
	pletter[19]->Draw(&memDC,x+95,y+145);
}

/////////////////////////////////////////////////////

}

void GameWindow::drawDebug()
{
//	CString str, str1;

//	str1=IntToStr(debug1)+"   "+IntToStr(debug2);
//	str="Hasgame: "+IntToStr(hasgame)+"  Gametick: "+IntToStr(gameTick);

//	str1=IntToStr(player1.mytrumpf);

	//if(player3.hasGame()==true)
/*
	CString has,pair;
	if (player1.hasGame()==true)has="1";
	else if (player2.hasGame()==true)has="2";
	else if (player3.hasGame()==true)has="3";
*/
	//int card=clickedCard;
	//if(player3.isCouple(card)==true)pair="Paar!";
	//else pair="kein Paar";

//	str1="gameTick: "+IntToStr(gameTick)+" hasGame: "+has+"  "+pair;

//	str1=IntToStr(cardToBeServed)+"; hasGame: "+has;

	//else str1="player3 does not have the game";

	//str1=IntToStr(value1)+" "+IntToStr(value2)+" "+IntToStr(value3);

//	int a1,a2,a3,a4,a5,a6,a7,a8;

//	player1.getCardArray(a1,a2,a3,a4,a5,a6,a7,a8);

//	str=str1+"  P1: "+IntToStr(a1)+" "+IntToStr(a2)+" "+IntToStr(a3)+" "+IntToStr(a4)
//		+" "+IntToStr(a5)+" "+IntToStr(a6)+" "+IntToStr(a7)+" "+IntToStr(a8);
/*
	player2.getCardArray(a1,a2,a3,a4,a5,a6,a7,a8);

	str=str+"   P2: "+IntToStr(a1)+" "+IntToStr(a2)+" "+IntToStr(a3)+" "+IntToStr(a4)
		+" "+IntToStr(a5)+" "+IntToStr(a6)+" "+IntToStr(a7)+" "+IntToStr(a8);

	player3.getCardArray(a1,a2,a3,a4,a5,a6,a7,a8);

	str=str+"  P3: "+IntToStr(a1)+" "+IntToStr(a2)+" "+IntToStr(a3)+" "+IntToStr(a4)
		+" "+IntToStr(a5)+" "+IntToStr(a6)+" "+IntToStr(a7)+" "+IntToStr(a8);
*/
//	DebugText(memDC, 3, 535, IntToStr(gameTick));
//	DebugText(memDC, 3, 535, IntToStr(gameTick)+" timer: "+IntToStr(timerKilled));
}

void GameWindow::drawMessages()
{	
	CString str, str1;
	
	if(player1.hasGame()==true)
	{
		if(gameTick<3)str=name1+" took the game for "+IntToStr(passvalue);
		else
			str=name1+" leads";
	}
	else if(player2.hasGame()==true)
	{
		if(gameTick<3)str=name2+" took the game for "+IntToStr(passvalue);
		else
			str=name2+" leads";
	}
	else if(player3.hasGame()==true)
	{
		if(gameTick<3)str=name3+" took the game for "+IntToStr(passvalue);
			else str="You lead";
	}
	else
		str="";

	if((gameTick==4||gameTick==5||(player3.hasGame()&&gameTick==3))&&mayClick==true)
		str1="Play your card";	
	else if(gameTick==1&&mayClick==true)
		str1="Click on 2 cards to bury";
	else if(gameTick==2&&mayClick==true)
		str1="Click on 1 more card to bury";
	else str1="";
	
	if(showMessage)
	{
		drawString(10, 7, str);
		drawString(10, 317, str1);
	}	

	if(pairtrumpf>0)
	{
		drawString(700, 7, "Trump:");
		pno_symbol[pairtrumpf-1]->DrawTransparent
		(&memDC,pairtrumpf==2?752:754,4,RGB(255,255,255));
	}	

	if(p1Anno&&player1.pilesize==0&&player2.pilesize==0&&player3.pilesize==0)
	{
		memDC.SetTextAlign(TA_CENTER);

		drawString(100, 215, name1);
		drawString(670, 215, name2);
		drawString(100, 525, name3);

		memDC.SetTextAlign(TA_LEFT);
	}
}

void GameWindow::drawCard(int x, int y, int index, bool open)
{
	int col, val;

	switch(index)
	{
	case 1:{col=1;	val=2;}		break;
		case 2:{col=2;	val=2;}		break;
			case 3:{col=3;	val=2;}		break;
				case 4:{col=4;	val=2;}		break;
					case 5:{col=1;	val=3;}		break;
	case 6:{col=2;	val=3;}		break;
		case 7:{col=3;	val=3;}		break;
			case 8:{col=4;	val=3;}		break;
				case 9:{col=1;	val=4;}		break;
					case 10:{col=2;	val=4;}		break;
	case 11:{col=3;	val=4;}		break;
		case 12:{col=4;	val=4;}		break;
			case 13:{col=1;	val=10;}		break;
				case 14:{col=2;	val=10;}		break;
					case 15:{col=3;	val=10;}		break;
	case 16:{col=4;	val=10;}		break;
		case 17:{col=1;	val=11;}		break;
			case 18:{col=2;	val=11;}		break;
				case 19:{col=3;	val=11;}		break;
					case 20:{col=4;	val=11;}		break;	
	}

	if(!open)val=0;
	drawCard(x, y, col, val);
}

void GameWindow::drawFans()
{
	int i, dist1, dist2, x=5, y=40;

	if(fan1.getNumber()>6)dist1=36;
	else dist1=50;

	if(fan2.getNumber()>6)dist2=36;
	else dist2=50;	

	if(fan1.getNumber()==5)x+=25;
	else if(fan1.getNumber()==4)x+=50;
	else if(fan1.getNumber()==3)x+=75;
	else if(fan1.getNumber()==2)x+=100;
	else if(fan1.getNumber()==1)x+=125;

	if(givingCards)x=5;

	for(i=0;i<8;i++)	
	{
		if(fan1.card[i]>0)
		{
		drawCard(x,y,fan1.card[i],m_cheat);		
		x+=dist1;
		}
	}
	
	y=350;
	x=5;

	if(fan3.getNumber()==5)x+=25;
	else if(fan3.getNumber()==4)x+=50;
	else if(fan3.getNumber()==3)x+=75;
	else if(fan3.getNumber()==2)x+=100;
	else if(fan3.getNumber()==1)x+=125;

	if(givingCards)x=5;

	for(i=0;i<8;i++)	
	{
		if(fan3.card[i]>0)
		{
		drawCard(x,y-pop[i],fan3.card[i]);		
		x+=50;
		}
	}
	
	y=40;
	x=410;	

	if(fan2.getNumber()==5)x+=25;
	else if(fan2.getNumber()==4)x+=50;
	else if(fan2.getNumber()==3)x+=75;
	else if(fan2.getNumber()==2)x+=100;
	else if(fan2.getNumber()==1)x+=125;

	if(givingCards)x=410;	

	for(i=0;i<8;i++)	
	{
		if(fan2.card[i]>0)
		{
		drawCard(x,y,fan2.card[i],m_cheat);		
		x+=dist2;
		}
	}	

	if(skat.card[0]>0)	drawCard(450,280,skat.card[0],m_cheat);		
	if(skat.card[1]>0)	drawCard(500,280,skat.card[1],m_cheat);	

	if(m_cheat)
	{
	if(pushedSkat.card[0]>0) drawCard(610,470,pushedSkat.card[0]);		
	if(pushedSkat.card[1]>0) drawCard(660,500,pushedSkat.card[1]);
	}

	if(pile.card[0]>0)	drawCard(450,280,pile.card[0]);		
	if(pile.card[1]>0)	drawCard(500,280,pile.card[1]);		
	if(pile.card[2]>0)	drawCard(550,280,pile.card[2]);		
}

void GameWindow::OnGameNew() 
{
	if(beginningPlayer<3)
		beginningPlayer++;
	else beginningPlayer=1;	
	
	fan1.removeFan();
	fan2.removeFan();
	fan3.removeFan();
	skat.removeFan();
	pushedSkat.removeFan();
	pile.removeFan();

	player1.hasGame(false);
	player2.hasGame(false);
	player3.hasGame(false);

	player1.pilevalue=0;
	player2.pilevalue=0;
	player3.pilevalue=0;

	player1.pilesize=0;
	player2.pilesize=0;
	player3.pilesize=0;

	player1.pairtrumpf=0;
	player2.pairtrumpf=0;
	player3.pairtrumpf=0;

	deck.shuffleDeck();

	int i;	

	cardToBeServed=0;

	givingCards=true;

	for(i=0;i<6;i++)
	{
	::Sleep(10);	
	fan1.addCard(deck.card[i].getIndex()); 
	drawStuff();

	::Sleep(10);	
	fan2.addCard(deck.card[i+6].getIndex()); 
	drawStuff();

	::Sleep(10);	
	fan3.addCard(deck.card[i+12].getIndex()); 
	drawStuff();
	}	

	::Sleep(10);
	skat.addCard(deck.card[18].getIndex()); 
	drawStuff();

	::Sleep(10);
	skat.addCard(deck.card[19].getIndex()); 
	drawStuff();

	fan1.SortForColors();
	fan2.SortForColors();
	fan3.SortForColors();

	player1.SortForColors();
	player2.SortForColors();
	player3.SortForColors();

	drawStuff();

	givingCards=false;

	player1.take6Cards(deck.card[0].getIndex(),deck.card[1].getIndex(),deck.card[2].getIndex(),
		deck.card[3].getIndex(),deck.card[4].getIndex(),deck.card[5].getIndex());

	player2.take6Cards(deck.card[6].getIndex(),deck.card[7].getIndex(),deck.card[8].getIndex(),
		deck.card[9].getIndex(),deck.card[10].getIndex(),deck.card[11].getIndex());

	player3.take6Cards(deck.card[12].getIndex(),deck.card[13].getIndex(),deck.card[14].getIndex(),
		deck.card[15].getIndex(),deck.card[16].getIndex(),deck.card[17].getIndex());

	value1=player1.evaluateFirstTime();
	value2=player2.evaluateFirstTime();	

	for(i=0;i<8;i++)
	{
		lastCardWidth[i]=0;
		pop[i]=0;
	}

	letPop=false;

	drawStuff();

	newGame=true;
	bidding=true;
	normalPlaying=false;
	pairtrumpf=0;
	hasgame=1;
	gameTick=-1;
	clickedCard=0;
	letTimerStart=true;
	clickTimeSpan=true;	

	SetTimer(IDT_TIMER1,speed,NULL);	
	timerKilled=0;

	p1Anno=p2Anno=p3Anno=true;
}

void GameWindow::driveGame()
{
	if(bidding)		//Das "Reizen"
	{
		bidding=false;				

		KillTimer(IDT_TIMER1);
		timerKilled=1;

		playedGames++;

		CBid bid;		

		bid.name1=name1;
		bid.name2=name2;
		bid.name3=name3;
			
		bid.beginningPlayer=beginningPlayer;
		bid.value1=value1;
		bid.value2=value2;				

		if(sound)sound2.Play();

		if(bid.DoModal()==IDOK)
		{				
			value3=bid.value3;	
			mostBidder=bid.mostBidder;	//wer kriegt das Spiel?
			passvalue=bid.passvalue;	//zu welchem "Preis"?
		}				

		if(mostBidder==1)
			player1.hasGame(true);
		else if(mostBidder==2)
			player2.hasGame(true);
		else if(mostBidder==3)
			player3.hasGame(true);
			
		SetTimer(IDT_TIMER1,speed,NULL);
		timerKilled=0;
		
		normalPlaying=true;
	}

	if(normalPlaying)
	{
		if(gameTick==0)
		{
			if(player1.hasGame()==true)
			{
				player1.takeSkat(deck.card[18].getIndex(), deck.card[19].getIndex());
				fan1.addCard(deck.card[18].getIndex());
				fan1.addCard(deck.card[19].getIndex());		

				fan1.SortForColors();
				player1.SortForColors();

				dealer=false;

				skat.removeFan();
			}

			else if(player2.hasGame()==true)
			{
				player2.takeSkat(deck.card[18].getIndex(), deck.card[19].getIndex());
				fan2.addCard(deck.card[18].getIndex());
				fan2.addCard(deck.card[19].getIndex());					

				fan2.SortForColors();
				player2.SortForColors();

				dealer=false;

				skat.removeFan();
			}

			else if(player3.hasGame()==true)
			{
				player3.takeSkat(deck.card[18].getIndex(), deck.card[19].getIndex());
				fan3.addCard(deck.card[18].getIndex());
				fan3.addCard(deck.card[19].getIndex());				

				fan3.SortForColors();
				player3.SortForColors();

				dealer=true;

				skat.removeFan();							
			}
		}

		else if(gameTick==1)
		{	
			showMessage=true;

			if(player1.hasGame()==true)
			{
				int c1,c2;				

				c1=player1.pushSkat();	
				c2=player1.pushSkat();	
				
				pushedSkat.addCard(c1);	
				pushedSkat.addCard(c2);	
				
				debug1=c1;
				debug2=c2;

				fan1.removeCard(c1);
				fan1.removeCard(c2);
			}

			else if(player2.hasGame()==true)
			{
				int c1,c2;
				
				c1=player2.pushSkat();	
				c2=player2.pushSkat();	

				pushedSkat.addCard(c1);	
				pushedSkat.addCard(c2);	
				
				debug1=c1;
				debug2=c2;

				fan2.removeCard(c1);
				fan2.removeCard(c2);
			}

			else if(player3.hasGame()==true)
			{
				KillTimer(IDT_TIMER1);
				timerKilled=1;

				letTimerStart=false;

				int card;

				mayClick=true;

				letPop=true;
				
				if(clickedCard>0)
				{
					card=clickedCard;					
					pushedSkat.addCard(card);
					player3.deleteCard(card);
					fan3.removeCard(card);			
					player3.pilevalue+=player3.getValue(card);
					player3.pilesize++;					
				}
			}
		}

		else if(gameTick==2)
		{			
			if(player1.hasGame()==true)
			{
				gameTick++;
				driveGame();
			}

			else if(player2.hasGame()==true)
			{
				gameTick++;
				driveGame();
			}

			else if(player3.hasGame()==true)
			{
				int card;				
				
				if(clickedCard>0&&mayClick)
				{
					card=clickedCard;					
					pushedSkat.addCard(card);	
					fan3.removeCard(card);	
					player3.deleteCard(card);
					player3.pilevalue+=player3.getValue(card);					
					player3.pilesize++;

				//	mayClick=false;
				}
			}			
		}

		else if(gameTick==3)	//Karte wird ausgespielt
		{
			letPop=true;

			//pushedSkat.removeFan();

			counter.deletePoints();

			if(player1.hasGame()==true)
			{				
				int card;

				card=player1.playCard();				

				cardToBeServed=card;

				trumpf=player1.getColor(card);

				if(player1.pairtrumpf>0&&p1Anno==true&&(player1.getValue(card)==KOENIG||player1.getValue(card)==DAME))
				{
					if(sound)sound1.Play();

					KillTimer(IDT_TIMER1);
					timerKilled=1;

					p1Anno=false;

					pairtrumpf=player1.pairtrumpf;					

					CString farbe;
					int bonus;

					if(pairtrumpf==1){farbe="Karo";bonus=40;}
					else if(pairtrumpf==2){farbe="Herz";bonus=60;}
					else if(pairtrumpf==3){farbe="Pik";bonus=80;}
					else if(pairtrumpf==4){farbe="Kreuz";bonus=100;}						

					CAnnounce annoDial;
					annoDial.m_icon=bonus;
					annoDial.m_str1=name1+" enters "+IntToStr(bonus);
					annoDial.DoModal();
					
					SetTimer(IDT_TIMER1,speed,NULL);
					timerKilled=0;

					player1.pilevalue+=bonus;					
				}
				else
					if(sound)sound3.Play();
				
				player2.setTrumpf(trumpf);
				player3.setTrumpf(trumpf);

				fan1.removeCard(card);

				pile.addCard(card);

				counter.count(1,card,pairtrumpf,true);
			}

			else if(player2.hasGame()==true)
			{	
				int card;

				card=player2.playCard();				

				cardToBeServed=card;

				trumpf=player2.getColor(card);

				if(player2.pairtrumpf>0&&p2Anno==true&&(player2.getValue(card)==KOENIG||player2.getValue(card)==DAME))
				{
					sound1.Play();

					KillTimer(IDT_TIMER1);
					timerKilled=1;

					p2Anno=false;

					pairtrumpf=player2.pairtrumpf;					

					CString farbe;

					int bonus;

					if(pairtrumpf==1){farbe="Karo";bonus=40;}
					else if(pairtrumpf==2){farbe="Herz";bonus=60;}
					else if(pairtrumpf==3){farbe="Pik";bonus=80;}
					else if(pairtrumpf==4){farbe="Kreuz";bonus=100;}										

					CAnnounce annoDial;
					annoDial.m_icon=bonus;
					annoDial.m_str1=name2+" enters "+IntToStr(bonus);
					annoDial.DoModal();

					SetTimer(IDT_TIMER1,speed,NULL);
					timerKilled=0;

					player2.pilevalue+=bonus;					
				}
				else 
					if(sound)sound3.Play();

				player1.setTrumpf(trumpf);
				player3.setTrumpf(trumpf);

				fan2.removeCard(card);

				pile.addCard(card);

				counter.count(2,card,pairtrumpf,true);
			}

			else if(player3.hasGame()==true)
			{	
				letTimerStart=true;
				KillTimer(IDT_TIMER1);
				timerKilled=1;

				if(clickTimeSpan)
					mayClick=true;

				int card;												

				if(clickedCard>0&&mayClick)
				{
					card=clickedCard;
					clickedCard=0;

					mayClick=false;
					
					trumpf=player3.getColor(card);		
					
				if(player3.getColor(card)!=pairtrumpf)
					p3Anno=true;

				if((p3Anno==true)&&(player3.isCouple(card)==true)
					&&(player3.getValue(card)==KOENIG
					||player3.getValue(card)==DAME))
				{
					sound1.Play();

					KillTimer(IDT_TIMER1);
					timerKilled=1;

					p3Anno=false;					

					pairtrumpf=player3.getColor(card);										

					CString farbe;

					int bonus;

					if(pairtrumpf==1){farbe="Karo";bonus=40;}
					else if(pairtrumpf==2){farbe="Herz";bonus=60;}
					else if(pairtrumpf==3){farbe="Pik";bonus=80;}
					else if(pairtrumpf==4){farbe="Kreuz";bonus=100;}												

					CAnnounce annoDial;
					annoDial.m_icon=bonus;
					annoDial.m_str1=name3+" enters "+IntToStr(bonus);
					annoDial.DoModal();

					SetTimer(IDT_TIMER1,speed,NULL);
					timerKilled=0;
					letTimerStart=true;

					player3.pilevalue+=bonus;					
				}
				else
					if(sound)sound3.Play();

				player1.setTrumpf(trumpf);
				player2.setTrumpf(trumpf);				
				
				fan3.removeCard(card);

				pile.addCard(card);

				player3.deleteCard(card);

				counter.count(3,card,pairtrumpf,true);
				}
			}
		}

		else if(gameTick==4)	//Erster Spieler gibt mit
		{
			if(player1.hasGame()==true)
			{	
				int card;

				card=player2.playCard();

				if(sound)sound3.Play();

				fan2.removeCard(card);

				pile.addCard(card);

				counter.count(2,card,pairtrumpf,false);
			}

			else if(player2.hasGame()==true)
			{	
				KillTimer(IDT_TIMER1);
				timerKilled=1;

				if(clickTimeSpan)mayClick=true;

				int card;				

				if(clickedCard>0&&mayClick)
				{
					card=clickedCard;
					clickedCard=0;				

					fan3.removeCard(card);

					player3.deleteCard(card);

					pile.addCard(card);

					counter.count(3,card,pairtrumpf,false);

					mayClick=false;
				}
			}	
			
			else if(player3.hasGame()==true)
			{	
				int card;

				card=player1.playCard();

				if(sound)sound3.Play();
				
				fan1.removeCard(card);

				pile.addCard(card);

				counter.count(1,card,pairtrumpf,false);
			}			
		}

		else if(gameTick==5)	//Zweiter Spieler gibt mit
		{
			if(player1.hasGame()==true)
			{	
				KillTimer(IDT_TIMER1);
				timerKilled=1;

				int card;	
				
				if(clickTimeSpan)mayClick=true;

				if(clickedCard>0&&mayClick)
				{
					card=clickedCard;
					clickedCard=0;				

					fan3.removeCard(card);

					player3.deleteCard(card);

					pile.addCard(card);

					counter.count(3,card,pairtrumpf,false);

					mayClick=false;
				}
			}

			else if(player2.hasGame()==true)
			{	
				int card;

				card=player1.playCard();

				if(sound)sound3.Play();

				fan1.removeCard(card);

				pile.addCard(card);

				counter.count(1,card,pairtrumpf,false);
			}	
			
			else if(player3.hasGame()==true)
			{	
				int card;

				card=player2.playCard();				

				if(sound)sound3.Play();

				fan2.removeCard(card);

				pile.addCard(card);

				counter.count(2,card,pairtrumpf,false);
			}			
		}

		else if(gameTick==6)	//Karten werden eingesammelt
		{
			mayClick=false;					

			if(counter.mostPoints()==1)
			{	
				player1.take3Cards(pile.card[0],pile.card[1],pile.card[2]);
				hasgame=1;
			}

			else if(counter.mostPoints()==2)
			{	
				player2.take3Cards(pile.card[0],pile.card[1],pile.card[2]);
				hasgame=2;
			}	
			
			else if(counter.mostPoints()==3)
			{	
				player3.take3Cards(pile.card[0],pile.card[1],pile.card[2]);
				hasgame=3;
			}	

			pile.removeFan();				
			
			drawStuff();

			if(hasgame==1)
			{
				player1.hasGame(true);
				player2.hasGame(false);
				player3.hasGame(false);

				dealer=false;
			}

			else if(hasgame==2)
			{
				player1.hasGame(false);
				player2.hasGame(true);
				player3.hasGame(false);

				dealer=false;
			}	
				
			else if(hasgame==3)
			{
				player1.hasGame(false);
				player2.hasGame(false);
				player3.hasGame(true);

				dealer=true;
			}				

			if(player1.getFansize()==0&&player2.getFansize()==0&&player3.getFansize()==0)
			{	
				showMessage=false;
				drawStuff();

				eval.playedGames=playedGames;

				int v1,v2,v3;				

				if(mostBidder==1)
				{
					if(passvalue>player1.getPileValue())
						v1=-passvalue; //wenn Eerreizt
					else 
						v1=player1.getPileValue();

						v2=player2.getPileValue();
						v3=player3.getPileValue();

					if(passvalue>player1.pilevalue)
						eval.m_text=name1+" missed the "+IntToStr(passvalue)+" points";					
					else
						eval.m_text="";
				}

				if(mostBidder==2)
				{
					if(passvalue>player2.getPileValue())
						v2=-passvalue; //wenn Eerreizt
					else 
						v2=player2.getPileValue();

						v1=player1.getPileValue();
						v3=player3.getPileValue();

					if(passvalue>player2.pilevalue)
						eval.m_text=name2+" missed the "+IntToStr(passvalue)+" points";
					else
						eval.m_text="";
				}

				if(mostBidder==3)
				{
					if(passvalue>player3.getPileValue())
						v3=-passvalue; //wenn Eerreizt
					else 
						v3=player3.getPileValue();

						v1=player1.getPileValue();
						v2=player2.getPileValue();

					if(passvalue>player3.pilevalue)
						eval.m_text=name3+" missed the "+IntToStr(passvalue)+" points";					
					else
						eval.m_text="";
				}				

				if(((v1 % 10)<6)&&v1>=0)
					v1=v1-(v1 % 10);
				else if(v1>=0)
					v1=v1-(v1 % 10)+10;

				if(((v2 % 10)<6)&&v2>=0)
					v2=v2-(v2 % 10);
				else if(v2>=0)
					v2=v2-(v2 % 10)+10;

				if(((v3 % 10)<6)&&v3>=0)
					v3=v3-(v3 % 10);
				else if(v3>=0)
					v3=v3-(v3 % 10)+10;

				eval.scoreP1[playedGames-1]=scoreP1[playedGames-1]=v1;
				eval.scoreP2[playedGames-1]=scoreP2[playedGames-1]=v2;
				eval.scoreP3[playedGames-1]=scoreP3[playedGames-1]=v3;

				KillTimer(IDT_TIMER1);

				eval.name1=name1;
				eval.name2=name2;
				eval.name3=name3;	

				if(sound)sound2.Play();

				if(eval.DoModal()==IDCANCEL)
					DestroyWindow();

				CScore scoreDialog;

				if(eval.winner==1)
					scoreDialog.m_winner=name1+" is the Winner!";
					else if(eval.winner==2)
						scoreDialog.m_winner=name2+" is the Winner!";
					else if (eval.winner==3)
						scoreDialog.m_winner=name3+" is the Winner!";		
				

				if(eval.winner>0)
				{					
					if(sound)sound2.Play();

					if(scoreDialog.DoModal()==IDCANCEL)
					DestroyWindow();

					eval.Reset();

					for(int i=0;i<50;i++)
					{
						scoreP1[i]=0;
						scoreP2[i]=0;
						scoreP3[i]=0;
					}

					playedGames=0;
				}				
				
				OnGameNew();
			}
		}		
	}
}

void GameWindow::OnLButtonDown(UINT nFlags, CPoint point) 
{	
	clickedCard=0;	
	
	OnMouseMove(nFlags, point);

	if(mayClick&&vert)
	{
		if(x>10+xx&&x<60+xx+lastCardWidth[0]&&(fan3.card[0]>0))		//1. Karte
		{	
			if(player3.IsLegalCard(cardToBeServed,fan3.card[0],dealer))
			clickedCard=fan3.card[0];		
		}
		else if(x>59+xx&&x<110+xx+lastCardWidth[1]&&(fan3.card[1]>0))	//2. Karte
		{			
			if(player3.IsLegalCard(cardToBeServed,fan3.card[1],dealer))
			clickedCard=fan3.card[1];		
		}
		else if(x>109+xx&&x<160+xx+lastCardWidth[2]&&(fan3.card[2]>0))	//3. Karte
		{			
			if(player3.IsLegalCard(cardToBeServed,fan3.card[2],dealer))
			clickedCard=fan3.card[2];		
		}
		else if(x>159+xx&&x<210+xx+lastCardWidth[3]&&(fan3.card[3]>0))	//4. Karte
		{			
			if(player3.IsLegalCard(cardToBeServed,fan3.card[3],dealer))
			clickedCard=fan3.card[3];
		}

		else if(x>209+xx&&x<260+xx+lastCardWidth[4]&&(fan3.card[4]>0))	//5. Karte
		{	
			if(player3.IsLegalCard(cardToBeServed,fan3.card[4],dealer))
			clickedCard=fan3.card[4];		
		}
		else if(x>59+xx&&x<310+xx+lastCardWidth[5]&&(fan3.card[5]>0))	//6. Karte
		{			
			if(player3.IsLegalCard(cardToBeServed,fan3.card[5],dealer))
			clickedCard=fan3.card[5];
		}
		else if(x>259+xx&&x<360+xx+lastCardWidth[6]&&(fan3.card[6]>0))	//7. Karte
		{			
			if(player3.IsLegalCard(cardToBeServed,fan3.card[6],dealer))
			clickedCard=fan3.card[6];		
		}
		else if(x>309+xx&&x<410+xx+lastCardWidth[7]&&(fan3.card[7]>0))	//8. Karte
		{		
			if(player3.IsLegalCard(cardToBeServed,fan3.card[7],dealer))
			clickedCard=fan3.card[7];		
		}
	}			

	if(clickedCard>0)
	{
		if(sound)sound3.Play();
		
		clickTimeSpan=false;

		SetTimer(IDT_TIMER3,500,NULL);

		driveGame();	

		if(letTimerStart)
		SetTimer(IDT_TIMER1,speed,NULL);
		
		else 
		{
			gameTick++;				
		}

		drawStuff();
	}			
}



void GameWindow::OnMouseMove(UINT nFlags, CPoint point) 
{
	if(fig>6)
	{
	x=point.x;
	y=point.y;
			
	if(y>350&&y<520)vert=true;
			   else vert=false; //vertikale Koordinaten stimmen?
	
	xx=-5;

	if(fan3.getNumber()==5)xx=20;
	else if(fan3.getNumber()==4)xx=45;
	else if(fan3.getNumber()==3)xx=70;
	else if(fan3.getNumber()==2)xx=95;
	else if(fan3.getNumber()==1)xx=120;	

	for(int i=0;i<8;i++)
	{
		lastCardWidth[i]=0;
		pop[i]=0;
	}

	lastCardWidth[fan3.getNumber()-1]=70;

	if(vert&&letPop)
	{
		if(x>10+xx&&x<60+xx+lastCardWidth[0]&&(fan3.card[0]>0))		//1. Karte
		{			
			if(player3.IsLegalCard(cardToBeServed,fan3.card[0],dealer))
				pop[0]=10;		
		}
		else if(x>59+xx&&x<110+xx+lastCardWidth[1]&&(fan3.card[1]>0))	//2. Karte
		{			
			if(player3.IsLegalCard(cardToBeServed,fan3.card[1],dealer))
			pop[1]=10;		
		}
		else if(x>109+xx&&x<160+xx+lastCardWidth[2]&&(fan3.card[2]>0))	//3. Karte
		{			
			if(player3.IsLegalCard(cardToBeServed,fan3.card[2],dealer))
			pop[2]=10;		
		}
		else if(x>159+xx&&x<210+xx+lastCardWidth[3]&&(fan3.card[3]>0))	//4. Karte
		{			
			if(player3.IsLegalCard(cardToBeServed,fan3.card[3],dealer))
			pop[3]=10;		
		}

		else if(x>209+xx&&x<260+xx+lastCardWidth[4]&&(fan3.card[4]>0))	//5. Karte
		{	
			if(player3.IsLegalCard(cardToBeServed,fan3.card[4],dealer))
			pop[4]=10;		
		}
		else if(x>59+xx&&x<310+xx+lastCardWidth[5]&&(fan3.card[5]>0))	//6. Karte
		{			
			if(player3.IsLegalCard(cardToBeServed,fan3.card[5],dealer))
			pop[5]=10;		
		}
		else if(x>259+xx&&x<360+xx+lastCardWidth[6]&&(fan3.card[6]>0))	//7. Karte
		{			
			if(player3.IsLegalCard(cardToBeServed,fan3.card[6],dealer))
			pop[6]=10;		
		}
		else if(x>309+xx&&x<410+xx+lastCardWidth[7]&&(fan3.card[7]>0))	//8. Karte
		{		
			if(player3.IsLegalCard(cardToBeServed,fan3.card[7],dealer))
			pop[7]=10;		
		}
	}	
	
	xx=-5;

	if(fan3.getNumber()==5)xx=20;
	else if(fan3.getNumber()==4)xx=45;
	else if(fan3.getNumber()==3)xx=70;
	else if(fan3.getNumber()==2)xx=95;
	else if(fan3.getNumber()==1)xx=120;	

	static bool p1=true;
	static bool p2=true;
	static bool p3=true;
	static bool p4=true;
	static bool p5=true;
	static bool p6=true;
	static bool p7=true;
	static bool p8=true;

	if(pop[0]==10&&p1&&sound){sound4.Play();p1=false;}
	if(pop[0]==0)p1=true;
	if(pop[1]==10&&p2&&sound){sound4.Play();p2=false;}
	if(pop[1]==0)p2=true;
	if(pop[2]==10&&p3&&sound){sound4.Play();p3=false;}
	if(pop[2]==0)p3=true;
	if(pop[3]==10&&p4&&sound){sound4.Play();p4=false;}
	if(pop[3]==0)p4=true;
	if(pop[4]==10&&p5&&sound){sound4.Play();p5=false;}
	if(pop[4]==0)p5=true;
	if(pop[5]==10&&p6&&sound){sound4.Play();p6=false;}
	if(pop[5]==0)p6=true;
	if(pop[6]==10&&p7&&sound){sound4.Play();p7=false;}
	if(pop[6]==0)p7=true;
	if(pop[7]==10&&p8&&sound){sound4.Play();p8=false;}
	if(pop[7]==0)p8=true;


	drawStuff();
	
	CFrameWnd::OnMouseMove(nFlags, point);
	}
}

void GameWindow::ShowSplashScreen(int f)
{	
	if(fig<7)
	{
		CFont *pOldFont=memDC.SelectObject(&font2);

		CString s;

		if(f>3&&f<7)s="1001";
		else if(f==3)s="100";
		else if(f==2)s="10";
		else if(f==1)s="1";
		else s="";

		int x=140;
		int y=130;

		memDC.SetBkMode(TRANSPARENT);	

		int c;

		for(int i=0;i<30;i++)
		{
			c=(int)(i*(float)255/30);	

			memDC.SetTextColor(RGB(c,50,50));
				memDC.TextOut(x,y,s);	
			x--;
			y--;
		}		
			
		memDC.SelectObject(pOldFont);
		memDC.SetBkMode(OPAQUE);	
		memDC.SetTextColor(RGB(0,0,0));
	}			
}

void GameWindow::drawPiles()
{
	int i, x1, x2, x3, y;

	x1=190-player1.pilesize*7;

	x2=600-player2.pilesize*7;

	x3=190-player3.pilesize*7;

	y=220;	
	
	for(i=0;i<player1.pilesize;i++)
	{
	plcard->Draw(&memDC,x1,y);
	x1+=13;
	}

	for(i=0;i<player2.pilesize;i++)
	{
	plcard->Draw(&memDC,x2,y);
	x2+=13;
	}

	y=530;

	for(i=0;i<player3.pilesize;i++)
	{
	plcard->Draw(&memDC,x3,y);
	x3+=13;
	}
}

void GameWindow::drawString(int x, int y, CString s)
{
	CFont *pOldFont=memDC.SelectObject(&font1);

	memDC.SetBkMode(TRANSPARENT);		

	memDC.SetTextColor(RGB(50,50,50));
		memDC.TextOut(x+2,y+2,s);	

	memDC.SetTextColor(RGB(255,255,0));
		memDC.TextOut(x,y,s);	
		
	memDC.SelectObject(pOldFont);
	memDC.SetBkMode(OPAQUE);	
	memDC.SetTextColor(RGB(0,0,0));
}

void GameWindow::loadSettings()
{
	cardcolor=::GetPrivateProfileInt(
		"CardGame:1001", "CardColors", 1, "CardGame1001.ini");

	int sInt=::GetPrivateProfileInt(
		"CardGame:1001", "Sound", 1, "CardGame1001.ini");

	if(sInt==1)sound=true;
	else sound=false;

	char txt[21];
	
	::GetPrivateProfileString (
		"CardGame:1001", "PlayerName1",
		"Player 1", txt, 21, "CardGame1001.ini");

	name1=txt;

	::GetPrivateProfileString (
		"CardGame:1001", "PlayerName2",
		"Player 2", txt, 21, "CardGame1001.ini");

	name2=txt;

	::GetPrivateProfileString (
		"CardGame:1001", "PlayerName3",
		"Player 3", txt, 21, "CardGame1001.ini");

	name3=txt;	
}

void GameWindow::saveSettings()
{
	CString s;	

	s.Format("%d", cardcolor);
	::WritePrivateProfileString(
		"CardGame:1001", "CardColors", s, "CardGame1001.ini");

	int sInt;
	if(sound)sInt=1;
	else sInt=0;

	s.Format("%d", sInt);
	::WritePrivateProfileString(
		"CardGame:1001", "Sound", s, "CardGame1001.ini");

	s.Format("%s", name1);
	::WritePrivateProfileString(
		"CardGame:1001", "PlayerName1", s, "CardGame1001.ini");

	s.Format("%s", name2);
	::WritePrivateProfileString(
		"CardGame:1001", "PlayerName2", s, "CardGame1001.ini");

	s.Format("%s", name3);
	::WritePrivateProfileString(
		"CardGame:1001", "PlayerName3", s, "CardGame1001.ini");
}
