#ifndef AFX_GAMEWINDOW_H__230532E0_90FB_11D2_91E6_081A0CC10E27__INCLUDED_
#define AFX_GAMEWINDOW_H__230532E0_90FB_11D2_91E6_081A0CC10E27__INCLUDED_

// GameWindow.h : Header-Datei
//
#include "CISBitmap.h"
#include "Deck.h"
#include "Fan.h"
#include "Player.h"
#include "Wave.h"
#include "Counter.h"
#include "Evaluation.h"

/////////////////////////////////////////////////////////////////////////////
// Rahmen GameWindow 

class GameWindow : public CFrameWnd
{	

// Attribute
public:
	GameWindow(LPCSTR ClassName);	
	
private:	
	bool sound;
	CWave sound1, sound2, sound3, sound4;
	CString name1, name2, name3;
	void saveSettings();
	void loadSettings();
	int cardcolor;
	void drawString(int x, int y, CString s);
	int speed;
	bool m_cheat;
	bool letPop;
	bool vert;
	void drawPiles();
	
	void ShowSplashScreen(int f);
	int fig;
	bool clickTimeSpan;
	int x, y, xx;
	bool showMessage;
	bool mayClick;
	bool letTimerStart;
	int timerKilled;
	int playedGames;	//gespielte Runden			
	int scoreP1[50];	//max. 50 Spiele bis 1001
	int scoreP2[50];
	int scoreP3[50];

	bool dealer;
	int cardToBeServed;
	int lastCardWidth[8];
	int pop[8];
	bool givingCards;
	void drawMessages();
	int passvalue;
	bool p1Anno;
	bool p2Anno;
	bool p3Anno;

	int mostBidder;
	int clickedCard;
	int pairtrumpf;
	int debug2;
	int debug1;
	bool skatWeglegen;
	int hasgame;
	bool dragMode;
	int trumpf;
	bool normalPlaying;
	bool bidding;
	bool newGame;
	int beginningPlayer;
	int gameTick;	
	void driveGame();
	int value1, value2, value3;
	void drawFans();
	void drawCard(int x, int y, int index, bool open=true);
	void drawDebug();
	void drawCard(int x, int y, int col, int val);
	CDC memDC, bgDC;
	CBitmap membmp, bgbmp, bg, bg1, *pbg1, bg2, *pbg2;	

	int width, height;
	
	CCISBitmap medail[3], *pmedail[3];	
	CCISBitmap bigsymbol[4], *pbigsymbol[4];	
	CCISBitmap smallsymbol[7], *psmallsymbol[7];	
	CCISBitmap letter[20], *pletter[20];	
	CCISBitmap no_symbol[4], *pno_symbol[4];
	CCISBitmap lcard, *plcard;

	CCISBitmap cardback1, *pcardback1;
	CCISBitmap cardback2, *pcardback2;
	CCISBitmap cardback3, *pcardback3;
	
	CBitmap pattern, *ppattern;
	CBitmap pattern1, *ppattern1;
	CBitmap pattern2, *ppattern2;

	CFont font1, font2;
	
	CToolBar m_Toolbar;

	CBrush redBrush;	
	CPen redPen;
	CPen blackPen;

	CDeck deck;
	CFan fan1, fan2, fan3, skat, pile, pushedSkat;

	CPlayer player1, player2, player3;

	CCounter counter;

	afx_msg void drawStuff();


// berschreibungen
	// Vom Klassen-Assistenten generierte virtuelle FunktionsEerschreibungen
	//{{AFX_VIRTUAL(GameWindow)
	//}}AFX_VIRTUAL

// Implementierung
protected:
	virtual ~GameWindow();

	// Generierte Nachrichtenzuordnungsfunktionen
	//{{AFX_MSG(GameWindow)
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);	
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnGameExit();
	afx_msg void OnClose();
	afx_msg void OnHelpTutorial();
	afx_msg void OnHelpAbout();
	afx_msg void OnGameNew();
	afx_msg void OnGameEvaluation();
	afx_msg void OnOptionsSettings();
	afx_msg void OnPaint();	
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio t zustzliche Deklarationen unmittelbar vor der vorhergehenden Zeile ein.

#endif // AFX_GAMEWINDOW_H__230532E0_90FB_11D2_91E6_081A0CC10E27__INCLUDED_
