// Player.cpp: Implementierung der Klasse CPlayer.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "stdafx.h"
#include "Player.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//color + trumpf1:
const int KARO=1;
const int HERZ=2;
const int PIK=3;
const int KREUZ=4;
//value:
const int BUBE=2;
const int DAME=3;
const int KOENIG=4;
const int ZEHN=10;
const int AS=11;

//index
//			KARO	HERZ	PIK		KREUZ
//BUBE		1		2		3		4
//DAME		5		6		7		8
//KOENIG	9		10		11		12
//ZEHN		13		14		15		16
//AS		17		18		19		20

//0=kein Prchen	=0
//1=Karo Prchen	=40
//2=Herz Prchen	=60
//3=Pik Prchen		=80
//4=Kreuz Prchen	=100

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CPlayer::CPlayer()
{
	hasgame=false;

	pilesize=0;	

	pilevalue=0;

	trumpf=0;

	for(int i=0;i<4;i++)
	{
		haveAS[i]=false;
		have10[i]=false;
		haveCouple[i]=false;
	}
}

CPlayer::~CPlayer()
{

}

int CPlayer::playCard()
{	
	int card;

	if(fansize>1)
	{
		cleanUp();
		card=calcNextCard();	
	}
	else
		card=cards[0];
	
	for(int i=0;i<fansize;i++)
		if(cards[i]==card)
			cards[i]=0;
	
	cleanUp();

	fansize--;
		
	return card;
}

int CPlayer::calcNextCard()	//welche Karte wird ausgespielt?
{
	int nextCard;	

	checkForAS();
	checkForCouple();	

	if(hasgame)
	{	
		//wenn "Strasse" vorhanden, dann ausspielen
		if(streetColor>0&&haveColor(streetColor))
			nextCard=getBiggestCard(streetColor,false);	
		
		//wenn "Mini-Strasse" vorhanden, dann ausspielen
		else if(miniStreetColor>0&&haveColor(miniStreetColor))
			nextCard=getBiggestCard(miniStreetColor,false);	

		//wenn AS vorhanden, dann ausspielen
		else if(getHaveAS())
			nextCard=getBiggestCard(false);	

		//wenn kein As von der Prchenfarbe, dann Prchen ausspielen
		else if(mytrumpf>0&&haveAS[mytrumpf-1]==false&&getKingOfPair()>0)
			nextCard=getKingOfPair();

		else
			nextCard=getBiggestCard(false);					
	}
	else if(!hasgame)
	{
		if(haveColor(trumpf))
			if(haveAS[trumpf-1])
				nextCard=getBiggestCard(trumpf, false);		
			else
				nextCard=getSmallestCard(trumpf, false);		

		else 
			nextCard=getSmallestCard(false);					
	}

	CString paircolor;	
	
	switch(mytrumpf)
	{
	case KARO:	paircolor="KARO";	break;
		case HERZ:	paircolor="HERZ";	break;
			case PIK:	paircolor="PIK";	break;
				case KREUZ:	paircolor="KREUZ";	break;
	}

	if((getValue(nextCard)==KOENIG)&&(haveCouple[getColor(nextCard)-1]==true))
	{				
		pairtrumpf=mytrumpf;	//zum Abfragen durch GameWindow
	}

	return nextCard;
}

void CPlayer::take3Cards(int i1, int i2, int i3)
{
	pile[pilesize+1]=i1;
	pile[pilesize+2]=i2;
	pile[pilesize+3]=i3;

	pilesize+=3;

	pilevalue+=getValue(i1);
	pilevalue+=getValue(i2);
	pilevalue+=getValue(i3);
}

void CPlayer::take6Cards(int i1, int i2, int i3, int i4, int i5, int i6)
{
	for(int i=0;i<4;i++)
	{
		haveAS[i]=false;
		have10[i]=false;
		haveCouple[i]=false;
	}

	cards[0]=i1;
	cards[1]=i2;
	cards[2]=i3;
	cards[3]=i4;
	cards[4]=i5;
	cards[5]=i6;
	cards[6]=0;
	cards[7]=0;

	fansize=6;	

	evaluateFirstTime();
}

void CPlayer::hasGame(bool hg)
{
	hasgame=hg;
}

bool CPlayer::hasGame()
{
	return hasgame;
}

void CPlayer::takeSkat(int i1, int i2)
{
	cards[fansize]=i1;
	cards[fansize+1]=i2;

	fansize=8;	

	checkForCouple();	
	mytrumpf=getCouple(); //(1..4)
	streetColor=checkForStreet();
	miniStreetColor=checkForMiniStreet();
}

int CPlayer::evaluateFirstTime()
{	
	value=0;
	pairtrumpf=0;
	streetColor=0;
	miniStreetColor=0;

	checkForCouple();		

	checkForAS();
	checkFor10();
	
	streetColor=checkForStreet();	

	miniStreetColor=checkForMiniStreet();
	
	value+=getFanValue();	//Wert des Blattes ermitteln

	value+=getCoupleValue(getCouple());	//Wert des Prchens

	value+=10;	// den "Skat"

	if(getCouple()==false&&value>120)value=120;

	return value;	
}

void CPlayer::setValue(int v)
{
	value=v;
}

void CPlayer::checkForAS()
{
	bool as1, as2, as3, as4;
	as1=as2=as3=as4=false;

	for(int i=0;i<fansize;i++)
	{
		if(cards[i]==17)
			as1=true;

		if(cards[i]==18)
			as2=true;

		if(cards[i]==19)
			as3=true;

		if(cards[i]==20)
			as4=true;
	}

	if(as1)haveAS[0]=true; else haveAS[0]=false;
	if(as2)haveAS[1]=true; else haveAS[1]=false;
	if(as3)haveAS[2]=true; else haveAS[2]=false;
	if(as4)haveAS[3]=true; else haveAS[3]=false;
}

void CPlayer::checkFor10()
{
	bool zehn1, zehn2, zehn3, zehn4;
	zehn1=zehn2=zehn3=zehn4=false;

	for(int i=0;i<fansize;i++)
	{
		if(cards[i]==13)
			zehn1=true;

		if(cards[i]==14)
			zehn2=true;

		if(cards[i]==15)
			zehn3=true;

		if(cards[i]==16)
			zehn4=true;
	}

	if(zehn1)have10[0]=true; else have10[0]=false;
	if(zehn2)have10[1]=true; else have10[1]=false;
	if(zehn3)have10[2]=true; else have10[2]=false;
	if(zehn4)have10[3]=true; else have10[3]=false;
}

//nachsehen, ob As, Zehn UND Knig, Dame oder Bube 
//von einer Farbe da ist

int CPlayer::checkForStreet()
{
	bool as1, as2, as3, as4;
	as1=as2=as3=as4=false;

	bool zehn1, zehn2, zehn3, zehn4;
	zehn1=zehn2=zehn3=zehn4=false;

	bool king1, king2, king3, king4;
	king1=king2=king3=king4=false;

	bool dame1, dame2, dame3, dame4;
	dame1=dame2=dame3=dame4=false;

	bool bube1, bube2, bube3, bube4;
	bube1=bube2=bube3=bube4=false;

	for(int i=0;i<fansize;i++)
	{
		if(cards[i]==17)as1=true;
		if(cards[i]==18)as2=true;
		if(cards[i]==19)as3=true;
		if(cards[i]==20)as4=true;

		if(cards[i]==13)zehn1=true;
		if(cards[i]==14)zehn2=true;
		if(cards[i]==15)zehn3=true;
		if(cards[i]==16)zehn4=true;

		if(cards[i]==9)king1=true; 			
		if(cards[i]==10)king2=true;			
		if(cards[i]==11)king3=true;	 			 
		if(cards[i]==12)king4=true; 

		if(cards[i]==5)dame1=true;
		if(cards[i]==6)dame2=true;
		if(cards[i]==7)dame3=true;
		if(cards[i]==8)dame4=true;

		if(cards[i]==1)bube1=true;
		if(cards[i]==2)bube2=true;
		if(cards[i]==3)bube3=true;
		if(cards[i]==4)bube4=true;
	}

	if(as4&&zehn4&&(king4||dame4||bube4))return 4;
	if(as3&&zehn3&&(king3||dame3||bube3))return 3;
	if(as2&&zehn2&&(king2||dame2||bube2))return 2;
	if(as1&&zehn1&&(king1||dame1||bube1))return 1;

	return 0;
}

//nachsehen, ob As und Zehn
//von einer Farbe da ist (keine streetColor!)
int CPlayer::checkForMiniStreet()
{
	bool as1, as2, as3, as4;
	as1=as2=as3=as4=false;

	bool zehn1, zehn2, zehn3, zehn4;
	zehn1=zehn2=zehn3=zehn4=false;

	for(int i=0;i<fansize;i++)
	{
		if(cards[i]==17)as1=true;
		if(cards[i]==18)as2=true;
		if(cards[i]==19)as3=true;
		if(cards[i]==20)as4=true;

		if(cards[i]==13)zehn1=true;
		if(cards[i]==14)zehn2=true;
		if(cards[i]==15)zehn3=true;
		if(cards[i]==16)zehn4=true;	
	}

	if(as4&&zehn4&&streetColor!=4)return 4;
	if(as3&&zehn3&&streetColor!=3)return 3;
	if(as2&&zehn2&&streetColor!=2)return 2;
	if(as1&&zehn1&&streetColor!=1)return 1;

	return 0;
}

void CPlayer::checkForCouple()
{
	if(getCouple()==4)
		haveCouple[3]=true; else haveCouple[3]=false;

	if(getCouple()==3)
		haveCouple[2]=true; else haveCouple[2]=false;

	if(getCouple()==2)
		haveCouple[1]=true; else haveCouple[1]=false;

	if(getCouple()==1)
		haveCouple[0]=true; else haveCouple[0]=false;
}

int CPlayer::getCouple()
{
	int couple;

	bool karoDame=false;
	bool karoKoenig=false;

	bool herzDame=false;
	bool herzKoenig=false;

	bool pikDame=false;
	bool pikKoenig=false;

	bool kreuzDame=false;
	bool kreuzKoenig=false;

	bool karoCouple=false;
	bool herzCouple=false;
	bool pikCouple=false;
	bool kreuzCouple=false;


	for(int i=0;i<fansize;i++)
	{
		if(cards[i]==5)			karoDame=true;
		else if(cards[i]==9)	karoKoenig=true; 
		else if(cards[i]==6)	herzDame=true;	
		else if(cards[i]==10)	herzKoenig=true; 
		else if(cards[i]==7)	pikDame=true;	
		else if(cards[i]==11)	pikKoenig=true;	 
		else if(cards[i]==8)	kreuzDame=true;	 
		else if(cards[i]==12)	kreuzKoenig=true; 
	}

	if(karoDame&&karoKoenig)karoCouple=true;					
	if(herzDame&&herzKoenig)herzCouple=true;				
	if(pikDame&&pikKoenig)pikCouple=true;					
	if(kreuzDame&&kreuzKoenig)kreuzCouple=true;					

	if(kreuzCouple)couple=4;
	else if(pikCouple)couple=3;
	else if(herzCouple)couple=2;
	else if(karoCouple)couple=1;

	else couple=0;

	return couple;
}

int CPlayer::getCoupleValue(int cv)
{
	int cvalue;

	switch(cv)
	{	
	case 4:		cvalue=100;		break;
	case 3:		cvalue=80;		break;
	case 2:		cvalue=60;		break;
	case 1:		cvalue=40;		break;

	case 0:		cvalue=0;		break;
	}

return cvalue;
}

void CPlayer::setTrumpf(int t)
{
	trumpf=t;
}

int CPlayer::getSmallestCard(bool value)
{
	int j, k;
	int smallest;	
	
	for(j=0; j<(fansize-1);j++)
	{
		for(k=j+1;k<fansize;k++)
		{
			order(cards[j],cards[k]);			
		}
	}	

	smallest=cards[0];
	
	if(value==true)
		return getValue(smallest);

	else
		return smallest;
}

int CPlayer::getSmallestCard(int color, bool value)
{
	int card;	
	getSmallestCard(false);
	
	if(haveColor(color)==false)card=0;
	else
	{
	for(int i=(fansize-1);i>=0;i--)
		if(getColor(cards[i])==color)
		{
			card=cards[i];			
		}
	}
	

	if(value==true)
		return getValue(card);

	else
		return card;
}

int CPlayer::getBiggestCard(int color, bool value)
{
	int card;	
	getBiggestCard(false);
	
	if(haveColor(color)==false)card=0;
	else
	{
	for(int i=0;i<fansize;i++)
		if(getColor(cards[i])==color)
		{
			card=cards[i];			
		}	
	}	

	if(value==true)
		return getValue(card);

	else 
		return card;
}

int CPlayer::getBiggestCard(bool value)
{
	int j, k;
	int biggest;	
	
	for(j=0; j<(fansize-1);j++)
	{
		for(k=j+1;k<fansize;k++)
		{
			order(cards[j],cards[k]);			
		}
	}	

	biggest=cards[fansize-1];			
	
	if(value==true)
		return getValue(biggest);
	
	else
		return biggest;
}		

void CPlayer::order(int& a, int& b)
{
	if(a>b)
	{
		int temp=a;
		a=b;
		b=temp;
	}
}

int CPlayer::getValue(int index)
{
	int value;

	if(index>0&&index<5)value=2;
	else if(index>4&&index<9)value=3;
	else if(index>8&&index<13)value=4;
	else if(index>12&&index<17)value=10;
	else if(index>16&&index<21)value=11;
	else value=0;

	return value;
}

int CPlayer::getColor(int index)
{	
	int color;

	switch(index)
	{
	case 1: color=KARO;		break;
		case 5: color=KARO;		break;
			case 9: color=KARO;		break;
				case 13: color=KARO;		break;
					case 17: color=KARO;		break;
	case 2: color=HERZ;		break;
		case 6: color=HERZ;		break;
			case 10: color=HERZ;		break;
				case 14: color=HERZ;		break;
					case 18: color=HERZ;		break;
	case 3: color=PIK;		break;
		case 7: color=PIK;		break;
			case 11: color=PIK;		break;
				case 15: color=PIK;		break;
					case 19: color=PIK;		break;
	case 4: color=KREUZ;		break;
		case 8: color=KREUZ;		break;
			case 12: color=KREUZ;		break;
				case 16: color=KREUZ;		break;
					case 20: color=KREUZ;		break;
	}

	return color;
}

bool CPlayer::haveColor(int color)
{
	for(int i=0;i<fansize;i++)
		if(getColor(cards[i])==color)
			return true;

	return false;
}

bool CPlayer::getHaveAS()
{
	checkForAS();
	
	if(haveAS[0]||haveAS[1]||haveAS[2]||haveAS[3])
		return true;
	
	return false;
}

void CPlayer::getCardArray(int &a0,int &a1,int &a2, int &a3,
						   int &a4, int &a5,int &a6, int &a7)
{
	a0=cards[0];
	a1=cards[1];
	a2=cards[2];
	a3=cards[3];
	a4=cards[4];
	a5=cards[5];
	a6=cards[6];
	a7=cards[7];
}

void CPlayer::Sort()
{
	int j, k;
		
	for(j=0; j<(fansize-1);j++)
	{
		for(k=j+1;k<fansize;k++)
		{
			order(cards[j],cards[k]);			
		}
	}	
}

int CPlayer::pushSkat()
{	
	int c=0;

	cleanUp();		
	/*
	for(emer=2;emer>=0;emer--)
	{
	value=BUBE;
	if(getSingle(value,emer)>0)
		c=getSingle(value,emer);		

	value=DAME;
	if(getSingle(value,emer)>0)
		c=getSingle(value,emer);	
	
	value=KOENIG;
	if(getSingle(value,emer)>0)
		c=getSingle(value,emer);		

	value=ZEHN;
	if(getSingle(value,emer)>0)
		c=getSingle(value,emer);
	}
	*/

	c=getSingle(ZEHN, 0);
	
	if(c==0)
		c=getSingle(KOENIG, 0);

	if(c==0)
		c=getSingle(DAME, 0);

	if(c==0)
		c=getSingle(BUBE, 0);

	if(c==0)
	
		c=getSingle(KOENIG, 1);

	if(c==0)
		c=getSingle(DAME, 1);

	if(c==0)
		c=getSingle(BUBE, 1);		

	if(c==0)
		c=getSingle(ZEHN, 2);


	pilevalue+=getValue(c);

	pile[pilesize+1]=c;
	pilesize++;

	deleteSpentCard(c);	

	cleanUp();	

	return c;			
}

int CPlayer::getSingle(int value, int emer)
{
	//sucht einzelne oder seltene Karten eines gegebenen Wertes
	int card=0;

	for(int i=0;i<fansize;i++)		//durchsuche ganzes Blatt
	{		
		int thisColor=getColor(cards[i]);

		if(emer==0)
		{
			//Wert stimmt mit gesuchtem Eerein
			if(getValue(cards[i])==value)
			{
				if(!(thisColor==streetColor||

					thisColor==miniStreetColor||

					(thisColor==getColor(getCouple()))))

					card=cards[i];
			}
		}
		else if(emer==1)
		{		
			if(getValue(cards[i])==value)
			{
				if(!(thisColor==miniStreetColor||

					(thisColor==getColor(getCouple())&&value==KOENIG)||

					(thisColor==getColor(getCouple())&&value==DAME)))

					card=cards[i];
			}
		}
		else if(emer==2)
		{		
			if(getValue(cards[i])==value)
			{
				if(!(thisColor==getColor(getCouple())&&value==KOENIG)||

					(thisColor==getColor(getCouple())&&value==DAME))

					card=cards[i];
			}
		}
	}	
	return card;
}

void CPlayer::cleanUp()
{
	for(int i=0;i<8;i++)		//"AufrEken"
		if(cards[i]==0)
		{
			if(i<7)
			{
				cards[i]=cards[i+1];
				cards[i+1]=0;
			}
		}		
}

void CPlayer::deleteSpentCard(int c)
{
	for(int i=0;i<fansize;i++)
	{
		if(cards[i]==c)
		{
			cards[i]=0;
			fansize--;
		}		
	}	
}

int CPlayer::getKingOfPair()
{
	int card;

	switch(mytrumpf)
	{
	case 1: card=9;	break;
		case 2: card=10;	break;
			case 3: card=11;	break;
				case 4: card=12;	break;
	}

	bool notAvailable=true;

	for(int i=0;i<(fansize-1);i++)
		if(cards[i]==card)notAvailable=false;

	if(notAvailable)
		return 0;	

	return card;
}

bool CPlayer::isCouple(int card)
{
	bool karoDame=false;
	bool karoKoenig=false;

	bool herzDame=false;
	bool herzKoenig=false;

	bool pikDame=false;
	bool pikKoenig=false;

	bool kreuzDame=false;
	bool kreuzKoenig=false;

	bool karoCouple=false;
	bool herzCouple=false;
	bool pikCouple=false;
	bool kreuzCouple=false;


	for(int i=0;i<fansize;i++)
	{
		if(cards[i]==5)			karoDame=true;
		else if(cards[i]==9)	karoKoenig=true; 
		else if(cards[i]==6)	herzDame=true;	
		else if(cards[i]==10)	herzKoenig=true; 
		else if(cards[i]==7)	pikDame=true;	
		else if(cards[i]==11)	pikKoenig=true;	 
		else if(cards[i]==8)	kreuzDame=true;	 
		else if(cards[i]==12)	kreuzKoenig=true; 
	}

	if(karoDame&&karoKoenig)karoCouple=true;					
	if(herzDame&&herzKoenig)herzCouple=true;				
	if(pikDame&&pikKoenig)pikCouple=true;					
	if(kreuzDame&&kreuzKoenig)kreuzCouple=true;					

	if(karoCouple&&(getColor(card)==KARO))return true;
	if(herzCouple&&(getColor(card)==HERZ))return true;
	if(pikCouple&&(getColor(card)==PIK))return true;
	if(kreuzCouple&&(getColor(card)==KREUZ))return true;
	
	return false;
}

int CPlayer::getPileValue()
{
	return pilevalue;
}

int CPlayer::getFanValue()
{
	int value=0;

	if(streetColor>0)value+=60;
	if(miniStreetColor>0)value+=40;

	for(int i=0;i<4;i++)
	{	
	if(haveAS[i]&&(streetColor!=i+1)&&
		(miniStreetColor!=i+1))value+=20;	

	if(streetColor==i+1&&getCouple()==i+1)
		value+=20;
	}

	return value;
}

bool CPlayer::IsLegalCard(int cardToBeServed, int queriedCard, bool dealer)
{
	//haben wir die Farbe,
	//ist die fragliche Karte von der Farbe, die zu bedienen ist
	//oder bin ich der Geber, dann sind alle Karten erlaubt

	if((getColor(cardToBeServed)==getColor(queriedCard))
		||(haveColor(getColor(cardToBeServed))==false)
		||dealer==true)	
	return true;

	return false;
}

void CPlayer::deleteCard(int card)
{
	cleanUp();	
	
	for(int i=0;i<fansize;i++)
		if(cards[i]==card)
			cards[i]=0;

	fansize--;	
	
	cleanUp();
}

void CPlayer::SortForColors()
{
	int i, j, k;	
	int tcard[8];
	
	for(j=0; j<(fansize-1);j++)
	{
		for(k=j+1;k<fansize;k++)
		{			
			order1(cards[j],cards[k]);			
		}
	}
	
	//Karte  Karte durchgehen
	//von Kreuz nach Karo durchprEen
	//wenn Farbe korrekt, dann in neues Array setzen
	//neues Array eins hochzhlen
	//Original-Array = neues Array setzen

	j=0;

	for(int col=4;col>0;col--)
	{
		for(i=0;i<fansize;i++)
		{
			if(getColor(cards[i])==col)
			{
			tcard[j]=cards[i];
			j++;
			}
		}	
	}

	for(i=0;i<fansize;i++)
	{	
		cards[i]=tcard[i];
	}

}

void CPlayer::order1(int &a, int &b)
{
	if(a<b)
	{
		int temp=a;
		a=b;
		b=temp;
	}
}

int CPlayer::getFansize()
{
	return fansize;
}




