// Player.h: Schnittstelle  die Klasse CPlayer.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PLAYER_H__FB0CEB20_7C1D_11D3_A5DF_E7B97E057C46__INCLUDED_)
#define AFX_PLAYER_H__FB0CEB20_7C1D_11D3_A5DF_E7B97E057C46__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Card.h"
#include "Announce.h"

class CPlayer  
{
public:		
	int getFansize();
	void SortForColors();
	void deleteCard(int card);
	bool IsLegalCard(int cardToBeServed, int queriedCard, bool dealer);
	int getPileValue();
	int pilevalue;
	bool isCouple(int card);
	int pairtrumpf;
	int pushSkat();	
	void Sort();
	void getCardArray(int&,int&,int&,int&,int&,int&,int&,int&);
	int getBiggestCard(int color,bool value);
	int getSmallestCard(int color,bool value);
	void setTrumpf(int t);
	bool hasGame();
	void setValue(int v);	
	int evaluateFirstTime();	
	void take3Cards(int i1, int i2, int i3);
	void take6Cards(int i1, int i2, int i3, int i4, int i5, int i6);
	int playCard();
	void takeSkat(int i1, int i2);
	int getColor(int index);
	void hasGame(bool hg);
	int getBiggestCard(bool value);
	int getSmallestCard(bool value);
	int getCouple();
	int getValue(int index);

	int pile[20];
	int pilesize;

	int mytrumpf;
	bool getHaveAS();

	CPlayer();
	virtual ~CPlayer();

private:	
	int checkForMiniStreet();
	int miniStreetColor;
	int streetColor;
	int checkForStreet();
	void order1(int& a, int&b);
	int getFanValue();
	int getKingOfPair();
	
	CAnnounce anno;
	void deleteSpentCard(int c);
	void cleanUp();
	int getSingle(int value, int emer);
	bool haveColor(int color);	
	
	void order(int& card1, int& card2);
	int trumpf;
	int calcNextCard();
	int getCoupleValue(int cv);
	
	void checkForCouple();
	void checkForAS();
	void checkFor10();

	bool haveAS[4];
	bool have10[4];
	bool haveCouple[4];

	int cards[8];	
	int fansize;
	int value;
	bool hasgame;
	CCard card;
};

#endif // !defined(AFX_PLAYER_H__FB0CEB20_7C1D_11D3_A5DF_E7B97E057C46__INCLUDED_)
